;********************************************************************
;               I2C Low and High Level Rutines
;        - I2C 
;        - Set Dac and Mas
;        - Set Controls(volume,treble,Bass)
;
; Ver 1.0                              Coded by Leandro Gentili /1999   
;********************************************************************

CONTROLS
              clrf PCLATH
              call REW_PRESS              
              movlw .8
              movwf PCLATH
              btfsc FLAG_KEY1,REW
              goto RESTO_C

              clrf PCLATH
              call FRD_PRESS
              movlw .8
              movwf PCLATH
              btfsc FLAG_KEY1,FRD
              goto SUMO_C
              clrf PCLATH
              return
SUMO_C
              movf CONTROL,w
              sublw .1
              btfsc STATUS,Z
              goto VOLU

              movf CONTROL,w
              sublw .2
              btfsc STATUS,Z
              goto BAS             

              movf TREBLE,w
              sublw .16
              btfss STATUS,Z
              incf TREBLE
              call TREBLE_MAS                
              goto MOST
VOLU
              movf VOLUMEN,w
              sublw .15 
              btfss STATUS,Z
              incf VOLUMEN
              call VOLUMEN_DAC            
              goto MOST
BAS
              movf BASS,w
              sublw .16
              btfss STATUS,Z
              incf BASS
              call BASS_MAS   
              goto MOST 
;********************************************
RESTO_C
              movf CONTROL,w
              sublw .1
              btfsc STATUS,Z
              goto VOLU1

              movf CONTROL,w
              sublw .2
              btfsc STATUS,Z
              goto BAS1

              movf TREBLE,w
              btfss STATUS,Z 
              decf TREBLE
              call TREBLE_MAS                         
              goto MOST
VOLU1
              movf VOLUMEN,w
              btfss STATUS,Z
              decf VOLUMEN
              call VOLUMEN_DAC          
              goto MOST
BAS1
              movf BASS,w
              btfss STATUS,Z
              decf BASS
              call BASS_MAS              
MOST
              call MOSTRAR_CONTROL
              return                             
;**********************************************************
;**********************************************************
INI_DAC
              movlw .3
              movwf N_BYTEIIC
              movlw 0x9A
              movwf BUFFERIIC
              movlw 0xC3
              movwf BUFFERIIC+1

              call SEND_BUFFER

              return
;**********************************************************
;**********************************************************
VOLUMEN_DAC
              movlw .4
              movwf N_BYTEIIC
              movlw 0x9A
              movwf BUFFERIIC
              movlw 0xC2
              movwf BUFFERIIC+1
              
              movf VOLUMEN,w
              addlw VOLUMEN_TABLE-BASE1
              call MORO2

              movwf BUFFERIIC+2
              movwf BUFFERIIC+3

              call SEND_BUFFER

              return
;**********************************************************
;**********************************************************               
BASS_MAS
              movf BASS,w
              movwf PRE
              call PRE_MAS

              movlw .6
              movwf N_BYTEIIC
              movlw 0x3A
              movwf BUFFERIIC
              movlw 0x68
              movwf BUFFERIIC+1
              movlw 0x96
              movwf BUFFERIIC+2
              movlw 0xB0
              movwf BUFFERIIC+3
             
              bcf STATUS,C
              rlf BASS,w
              addlw BASS_TABLE-BASE1
              call MORO2

              movwf BUFFERIIC+4

              bcf STATUS,C
              rlf BASS,w
              addlw .1
              addlw BASS_TABLE-BASE1
              call MORO2
               
              movwf BUFFERIIC+5
              
              call SEND_BUFFER              

              return
;**********************************************************
;**********************************************************               
TREBLE_MAS
              movf TREBLE,w
              movwf PRE
              call PRE_MAS

              movlw .6
              movwf N_BYTEIIC
              movlw 0x3A
              movwf BUFFERIIC
              movlw 0x68
              movwf BUFFERIIC+1
              movlw 0x96
              movwf BUFFERIIC+2
              movlw 0xF0
              movwf BUFFERIIC+3
             
              bcf STATUS,C
              rlf TREBLE,w
              addlw TREBLE_TABLE-BASE1
              call MORO2

              movwf BUFFERIIC+4

              bcf STATUS,C
              rlf TREBLE,w
              addlw .1
              addlw TREBLE_TABLE-BASE1
              call MORO2
               
              movwf BUFFERIIC+5
              
              call SEND_BUFFER

              return
;**********************************************************
;**********************************************************               
PRE_MAS
              movlw .6
              movwf N_BYTEIIC
              movlw 0x3A
              movwf BUFFERIIC
              movlw 0x68
              movwf BUFFERIIC+1
              movlw 0x9E
              movwf BUFFERIIC+2
              movlw 0x70
              movwf BUFFERIIC+3
             
              bcf STATUS,C
              rlf PRE,w
              addlw PRE_TABLE-BASE1
              call MORO2

              movwf BUFFERIIC+4

              bcf STATUS,C
              rlf PRE,w
              addlw .1
              addlw PRE_TABLE-BASE1
              call MORO2
               
              movwf BUFFERIIC+5
              
              call SEND_BUFFER

              return
;**********************************************************
;**********************************************************
MORO2   
              movwf TEMPW
              movlw 0x0E
              movwf PCLATH
              movf TEMPW,w
              movwf PCL                                         
;**********************************************************
;**********************************************************
SEND_BUFFER
              call INI_IIC 

              call START_IIC
               
              movlw BUFFERIIC
              movwf FSR
OTROFUERA
              movf INDF,w
              movwf BYTEIIC
 
              call OUT_IIC

              call GETACK_IIC

              incf FSR
              decfsz N_BYTEIIC               
              goto OTROFUERA

              call STOP_IIC

              return
;*********************************
;*********************************
INI_IIC 
              bsf STATUS,RP0
              bcf TRISA,SCL
              bcf TRISA,SDA
              bcf STATUS,RP0
            
              clrf PORTA
              return 
;*********************************
;*********************************
START_IIC
              sdaup               
              nop
              nop
              nop
              sclup
              nop
              nop
              nop
              sdadown
              nop
              nop
              nop
              scldown
              nop
              nop
              nop
              return
;*********************************
;*********************************
STOP_IIC
              sdadown
              nop
              nop
              nop
              sclup
              nop
              nop
              nop
              sdaup
              nop
              nop
              nop
              return
;*********************************
;*********************************
GETACK_IIC
              sdaup
              nop
              nop
              nop
HMMS
              sclup
              btfss PORTA,SCL
              goto HMMS

              bcf FLAG,ACK
              btfsc PORTA,SDA
              goto MAMA
              nop
              nop
              nop
              scldown
              return
MAMA 
              goto MAMA
;*********************************
;*********************************
OUT_IIC
              movlw .8
              movwf COUNTER
LOOP11
              nop
              nop
              nop
              btfsc BYTEIIC,7
              goto UPP
              sdadown
              goto HMMS1
UPP
              sdaup 
HMMS1
              nop
              nop
              nop
              sclup
              btfss PORTA,SCL
              goto HMMS1
              rlf BYTEIIC
              nop
              nop
              nop
              scldown
              decfsz COUNTER
              goto LOOP11
              return
;*********************************
;*********************************


                                   
                         

